# -*- coding: cp1252 -*-
# puzzle_a_stern.py
# ----- aus puzzle.py -----
# Grundfunktionen fr A*
# Zur einfacheren Behandlung wird das leere Feld mit dem Wert 0 belegt.
ziel=[[1,2,3],[4,5,6],[7,8,0]]

def findeZeile(feld, wert):
    for zeilenIndex in range(3):
        if wert in feld[zeilenIndex]: return zeilenIndex
def findeSpalte(zeile, wert):
    for spaltenIndex in range(3):
        if wert == zeile[spaltenIndex]: return spaltenIndex
def findePosition(feld, wert):
    if not wert in range(9): return False 
    z=findeZeile(feld, wert)
    s=findeSpalte(feld[z], wert)
    return (z, s)

def differenz(position, leer):
    return (abs(position[0]-leer[0]),abs(position[1]-leer[1]))

def setze(feld, zahl):
    if not zahl in range(1,9): return feld # unzulssiger Wert
    gewaehlt=findePosition(feld, zahl)
    leer=findePosition(feld, 0)
    if not differenz(gewaehlt, leer) in [(0,1),(1,0)]: return feld
    neu=[[feld[0][0],feld[0][1],feld[0][2]],[feld[1][0],feld[1][1],feld[1][2]],[feld[2][0],feld[2][1],feld[2][2]]]
    neu[leer[0]][leer[1]]=zahl                     # 0 berschreiben
    neu[gewaehlt[0]][gewaehlt[1]]=0                # 0 neu setzen
    return neu

import random
def mische(feld, anzahl):
    # Kopie erzeugen!
    for i in range(anzahl):
        feld=setze(feld, random.randint(1, 9))
    return feld
start=mische(ziel, 20)

def zeigeFeld(feld):
    for zeile in feld:
        zeilenString=''
        for wert in zeile:
            if wert!=0: zeilenString+=str(wert)+' '
            else: zeilenString+='  '
        print( zeilenString )

# ----- aus nachfolger.py -----
def zulaessig(index):
    return (index>=0) and (index<3)

def nachfolger(feld, zuletztBewegt):
    (z,s)=findePosition(feld, 0)
    neuePositionen=[(z-1,s),(z+1,s),(z,s-1),(z,s+1)]
    wertAlternativen=[]
    for pos in neuePositionen:
        if zulaessig(pos[0]):
            if zulaessig(pos[1]):
                if zuletztBewegt!=feld[pos[0]][pos[1]]:
                    wertAlternativen.append(feld[pos[0]][pos[1]])
    #print( feld, zuletztBewegt, wertAlternativen )
    return wertAlternativen

# ----- aus kostenfunktion.py -----
def restkosten(feld):
    for wert in range(1,9):
        ist=findePosition(feld, wert)
        soll=findePosition(ziel, wert)
    return abs(ist[0]-soll[0])+abs(ist[1]-soll[1])

def gesamtkosten(zustand, ziel):
    return len(zustand[0])+restkosten(zustand[1])

# ----- aus prioschlange.py -----
def besser(zustand1, zustand2, ziel):
    return gesamtkosten(zustand1, ziel)<gesamtkosten(zustand2, ziel)

def fuegeEin(zustand, schlange, ziel):
    for alternative in schlange:
        if besser(zustand, alternative, ziel):
            pos=schlange.index(alternative)
            schlange[pos:pos]=[zustand]
            return schlange
    pos=len(schlange)
    schlange[pos:pos]=[zustand]
    return schlange

# ----- aus AStern-Suche.py -----
def feldKopie(feld):
    neu=[]
    for zeile in feld:
        neueZeile=[]
        for spalte in zeile:
            neueZeile.append(spalte)
        neu.append(neueZeile)
    return neu

def suche(start, ziel):
    print( start )
    weg=[]
    feld=feldKopie(start)
    zuletztBewegt=None
    schlange=[[weg, feld]]
    return schritt(schlange, ziel)

def schritt(schlange, ziel):
    #print( schlange )
    #if (raw_input("weiter?")=='n'): return
    weg,feld=schlange[0]
    if (feld==ziel):
        return schlange[0]
    if weg==[]: zuletztBewegt=None
    else: zuletztBewegt=weg[len(weg)-1]
    weiterMit=nachfolger(feld, zuletztBewegt)
    schlange=schlange[1:]
    for zahl in weiterMit:
        zustand=[weg+[zahl],setze(feldKopie(feld), zahl)]
        schlange=fuegeEin(zustand, schlange, ziel)
    return schritt(schlange, ziel)

# ----- aus zeige-verschiebungen.py -----
def zeigeFeld(feld):
    print( '-----' )
    for zeile in feld:
        zeilenString=''
        for wert in zeile:
            if wert!=0: zeilenString+=str(wert)+' '
            else: zeilenString+='  '
        print( zeilenString )
    print( '-----' )

def zeigeVerschiebungen(start, bewegte):
    feld=feldKopie(start)
    zeigeFeld(feld)
    for bewegt in bewegte:
        feld=setze(feld, bewegt)
        zeigeFeld(feld)

start=mische(ziel,40)
loesung=suche(start,ziel)
print( loesung )
zeigeVerschiebungen(start, loesung[0])
